zoukankan      html  css  js  c++  java
  • UVa12097 Pie

    Problem C - Pie

    Time limit: 1 second

     My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

    My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

    What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

    Input

    One line with a positive integer: the number of test cases. Then for each test case:

    • One line with two integers N and F with 1 ≤ N, F ≤ 10000: the number of pies and the number of friends.
    • One line with N integers ri with 1 ≤ ri ≤ 10000: the radii of the pies.

    Output

    For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10-3.

    Sample Input

    3
    3 3
    4 3 3
    1 24
    5
    10 5
    1 4 2 3 4 5 6 5 4 2
    

    Sample Output

    25.1327
    3.1416
    50.2655
    
    The 2006 ACM Northwestern European Programming Contest
    题目大意:有N个pie,分给F+1个人,使得分给每个人的面积尽量大,每个人分得的pie都是整块的,不能是有几块拼凑起来的。
    题解:果断二分答案。不过代码写出来运行之后输出结果是比答案小一点,也就是精度有问题,我二分答案的时候中间值是m=l+(r-l+1)/2,由于答案是浮点型的,但似乎这个答案是整数时才能用,改成m=(l+r)/2之后,精度没问题了,提交上去WA了,也就是说精度还是有问题,然后发现我的π值是宏定义=3.1415926535898。而《训练指南》上是定义了一个浮点常量PI=acos(-1.0),所以我也修改了一下,提交上去就AC了。这样看来精度也是个很重要的问题,如果没控制好,很难被发现。因此在二分答案的时候要看清楚答案是整型还是浮点型,再选取相应的中间值表达式,在需要用到π常量的时候一律用Pi=acos(-1.0)。
    View Code
     1 #include<stdio.h>
     2 #include<stdlib.h>
     3 #include<math.h>
     4 #define MAXN 10005
     5 const double Pi=acos(-1.0);
     6 double radii[MAXN];
     7 int n,f;
     8 int check(double s)
     9 {
    10     int i,ans;
    11     ans=0;
    12     for(i=0; i<n; i++)
    13         ans+=floor(radii[i]/s);
    14     if(ans>=f+1) return 1;
    15     else
    16         return 0;
    17 }
    18 int main(void)
    19 {
    20     int i,T,rr;
    21     double l,r,m,maxr;
    22     scanf("%d",&T);
    23     while(T--)
    24     {
    25         scanf("%d%d",&n,&f);
    26         maxr=-1000;
    27         for(i=0; i<n; i++)
    28         {
    29             scanf("%d",&rr);
    30             radii[i]=Pi*rr*rr;
    31             if(radii[i]>maxr) maxr=radii[i];
    32 
    33         }
    34         l=0;
    35         r=maxr;
    36         while(r-l>1e-5)
    37         {
    38             m=(l+r)/2;
    39             if(check(m)) l=m;
    40             else
    41                 r=m;
    42         }
    43         printf("%.4lf\n",l);
    44     }
    45     return 0;
    46 }
  • 相关阅读:
    js事件循环机制event-loop
    javascript编译与执行
    css中rem,em,px的区别和使用场景
    float
    flex布局
    azoux's blog
    1004 成绩排名 PAT Basic Level
    1003 我要通过! PTA Basic Level
    腾讯云防盗链测试
    简单多项式求解
  • 原文地址:https://www.cnblogs.com/zjbztianya/p/2976310.html
Copyright © 2011-2022 走看看